using System;
using System.Collections.Generic;
using System.Text;

namespace RFC2396
{
    /// <summary>
    /// This class represents a RFC2396 URL.
    /// </summary>
    public class RFC2396Url
    {
        private string stringUrl = string.Empty;

        /// <summary>
        /// Public constructor of the class.
        /// </summary>
        /// <param name="url">URL to use with class.</param>
        public RFC2396Url(string url)
        {
            this.stringUrl = url;
        }

        /// <summary>
        /// Canonicalizes the URL.
        /// </summary>
        /// <returns>Canonicalized URL.</returns>
        public string Canonicalize()
        {            
            Canonicalization canonicalization = new Canonicalization();
            return canonicalization.GetCanonicalizedUrl(this.stringUrl);
        }
    }
}
