﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using RFC2396;

namespace RFC2396UnitTest
{
    /// <summary>
    ///This is a test class for RFC2396.Canonicalization and is intended
    ///to contain all RFC2396.Canonicalization Unit Tests
    ///</summary>
    [TestClass()]
    public class CanonicalizationTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion



        /// <summary>
        ///A test for GetHostName (string)
        ///</summary>
        [DeploymentItem("RFC2396.dll")]
        [TestMethod()]
        public void GetHostNameTest()
        {
            Canonicalization target = new Canonicalization();

            RFC2396UnitTest.RFC2396_CanonicalizationAccessor accessor = new RFC2396UnitTest.RFC2396_CanonicalizationAccessor(target);

            string url = "http://1.2.nayyeri$.net/1/2/3.html";

            string expected = "1.2.nayyeri$.net";
            string actual;

            actual = accessor.GetHostName(url);

            Assert.AreEqual(expected, actual, "RFC2396.Canonicalization.GetHostName did not return the expected value.");
        }

        /// <summary>
        ///A test for GetRemainder (string)
        ///</summary>
        [DeploymentItem("RFC2396.dll")]
        [TestMethod()]
        public void GetRemainderTest()
        {
            Canonicalization target = new Canonicalization();

            RFC2396UnitTest.RFC2396_CanonicalizationAccessor accessor = new RFC2396UnitTest.RFC2396_CanonicalizationAccessor(target);

            string url = "http://1.2.nayyeri$.net/1/2/3.html";

            string expected = "/1/2/3.html";
            string actual;

            actual = accessor.GetRemainder(url);

            Assert.AreEqual(expected, actual, "RFC2396.Canonicalization.GetRemainder did not return the expected value.");
        }

        /// <summary>
        ///A test for RemoveSpecialCharacters (string)
        ///</summary>
        [DeploymentItem("RFC2396.dll")]
        [TestMethod()]
        public void RemoveSpecialCharactersTest()
        {
            Canonicalization target = new Canonicalization();

            RFC2396UnitTest.RFC2396_CanonicalizationAccessor accessor = new RFC2396UnitTest.RFC2396_CanonicalizationAccessor(target);

            string hostname = @"1.2.nayyeri.net";

            string expected = "1.2.nayyeri.net";
            string actual;

            actual = accessor.RemoveSpecialCharacters(hostname);

            Assert.AreEqual(expected, actual, "RFC2396.Canonicalization.RemoveSpecialCharacters did not return the expected valu" +
                    "e.");
        }

        /// <summary>
        ///A test for ReplaceConsecutiveDots (string)
        ///</summary>
        [DeploymentItem("RFC2396.dll")]
        [TestMethod()]
        public void ReplaceConsecutiveDotsTest()
        {
            Canonicalization target = new Canonicalization();

            RFC2396UnitTest.RFC2396_CanonicalizationAccessor accessor = new RFC2396UnitTest.RFC2396_CanonicalizationAccessor(target);

            string hostname = "1.2...nay.........yeri.ne...t";

            string expected = "1.2.nay.yeri.ne.t";
            string actual;

            actual = accessor.ReplaceConsecutiveDots(hostname);

            Assert.AreEqual(expected, actual, "RFC2396.Canonicalization.ReplaceConsecutiveDots did not return the expected value" +
                    ".");
        }

        /// <summary>
        ///A test for EscapeSpecialChars (string)
        ///</summary>
        [DeploymentItem("RFC2396.dll")]
        [TestMethod()]
        public void EscapeSpecialCharsTest()
        {
            Canonicalization target = new Canonicalization();

            RFC2396UnitTest.RFC2396_CanonicalizationAccessor accessor = new RFC2396UnitTest.RFC2396_CanonicalizationAccessor(target);

            string hostname = "1.2.Nayy&e!ri.net";

            string expected = "1.2.Nayyeri.net";
            string actual;

            actual = accessor.EscapeSpecialChars(hostname);

            Assert.AreEqual(expected, actual, "RFC2396.Canonicalization.EscapeSpecialChars did not return the expected value.");
        }

        /// <summary>
        ///A test for ResolveSequences (string)
        ///</summary>
        [DeploymentItem("RFC2396.dll")]
        [TestMethod()]
        public void ResolveSequencesTest()
        {
            Canonicalization target = new Canonicalization();

            RFC2396UnitTest.RFC2396_CanonicalizationAccessor accessor = new RFC2396UnitTest.RFC2396_CanonicalizationAccessor(target);

            string remainder = "/12/35/../gdfg/./sdff5/../gh.html";

            string expected = "/12/gdfg/gh.html";
            string actual;

            actual = accessor.ResolveSequences(remainder);

            Assert.AreEqual(expected, actual, "RFC2396.Canonicalization.ResolveSequences did not return the expected value.");
        }

        /// <summary>
        ///A test for RemoveFragmentIdentifier (string)
        ///</summary>
        [DeploymentItem("RFC2396.dll")]
        [TestMethod()]
        public void RemoveFragmentIdentifierTest()
        {
            Canonicalization target = new Canonicalization();

            RFC2396UnitTest.RFC2396_CanonicalizationAccessor accessor = new RFC2396UnitTest.RFC2396_CanonicalizationAccessor(target);

            string remainder = "/12/35/gdfg/gh.html#fdgdfgfdg.dfgdfg.dfgfdg";

            string expected = "/12/35/gdfg/gh.html";
            string actual;

            actual = accessor.RemoveFragmentIdentifier(remainder);

            Assert.AreEqual(expected, actual, "RFC2396.Canonicalization.RemoveFragmentIdentifier did not return the expected val" +
                    "ue.");
        }

        /// <summary>
        ///A test for GetCanonicalizedUrl (string)
        ///</summary>
        [TestMethod()]
        public void GetCanonicalizedUrlTest()
        {
            Canonicalization target = new Canonicalization();

            string url = "http://1.2.nayyeri$.net/1/dfg/./3/dsfds/sdfdsf/../sdfdsf.html#dfgdfg.dgdgdfg";

            string expected = "1.2.nayyeri.net/1/dfg/3/dsfds/sdfdsf.html";
            string actual;

            actual = target.GetCanonicalizedUrl(url);

            Assert.AreEqual(expected, actual, "RFC2396.Canonicalization.GetCanonicalizedUrl did not return the expected value.");
        }
    }
}
